Attribute VB_Name = "modGlobals"
Option Explicit

Public mHelper As IPluginHelper

Private Declare Function SendMessageA Lib "user32" ( _
    ByVal hwnd As Long, ByVal wMsg As Long, _
    ByVal wParam As Long, ByVal lParam As Any _
    ) As Long
  
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" ( _
    ByVal hwnd As Long, _
    ByVal lpOperation As String, _
    ByVal lpFile As String, _
    ByVal lpParameters As String, _
    ByVal lpDirectory As String, _
    ByVal nShowCmd As Long _
    ) As Long

Private Const EM_GETLINE = &HC4
Private Const EM_GETLINECOUNT = &HBA
Private Const EM_SCROLLCARET = &HB7

Private Function TextBoxLineLength(ByRef txt As TextBox, ByVal Index As Long) As Long
    TextBoxLineLength = SendMessageA(txt.hwnd, EM_GETLINE, Index, 0&)
End Function

Public Function TextBoxLine(ByRef txt As TextBox, ByVal Index As Long) As String
    Dim Buffer As String * 1024
    Dim Length As Long
  
    Buffer = Chr$(Len(Buffer) And &HFF) & Chr$(Len(Buffer) \ &H100)
    Length = SendMessageA(txt.hwnd, EM_GETLINE, Index, Buffer)
    TextBoxLine = Left$(Buffer, Length)
End Function

Public Function TextBoxLineCount(ByRef txt As TextBox) As Long
    TextBoxLineCount = SendMessageA(txt.hwnd, EM_GETLINECOUNT, 0, 0&)
End Function

Public Function TextBoxContainsLine(ByRef txt As TextBox, ByVal Line As String) As Boolean
    Dim i As Long
    For i = 0 To TextBoxLineCount(txt)
        If StrComp(TextBoxLine(txt, i), Line, vbTextCompare) = 0 Then
            TextBoxContainsLine = True
            Exit Function
        End If
    Next i
End Function

Public Sub TextBoxAddLine(ByRef txt As TextBox, ByVal Line As String)
    If StrComp(txt.Text, "") <> 0 Then
        txt.Text = txt.Text & vbCrLf
    End If
    txt.Text = txt.Text & Line
End Sub

Public Sub TextBoxRemoveLine(ByRef txt As TextBox, ByVal Index As Long)
    If Index <> 0 Then
        
    End If
End Sub

Public Sub TextBoxRemoveLineByString(ByRef txt As TextBox, ByVal Line As String)

End Sub

Public Sub TextBoxIndexOf(ByRef txt As TextBox, ByVal Line As String)

End Sub

Public Function FileExists(FileName As String) As Boolean
    If FileName <> "" Then
        FileExists = (Dir$(FileName) <> "")
    Else
        FileExists = False
    End If
End Function
